/*!
 * Copyright (c) 2016 Chris O'Hara <cohara87@gmail.com>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.validator=t()}(this,function(){"use strict";function e(e){if("string"!=typeof e)throw new TypeError("This library (validator.js) validates strings only")}function t(t){return e(t),t=Date.parse(t),isNaN(t)?null:new Date(t)}function o(t){return e(t),parseFloat(t)}function r(t,o){return e(t),parseInt(t,o||10)}function i(t,o){return e(t),o?"1"===t||"true"===t:"0"!==t&&"false"!==t&&""!==t}function n(t,o){return e(t),t===o}function l(e){return"object"===("undefined"==typeof e?"undefined":ge(e))&&null!==e?e="function"==typeof e.toString?e.toString():"[object Object]":(null===e||"undefined"==typeof e||isNaN(e)&&!e.length)&&(e=""),String(e)}function a(t,o){return e(t),t.indexOf(l(o))>=0}function u(t,o,r){return e(t),"[object RegExp]"!==Object.prototype.toString.call(o)&&(o=new RegExp(o,r)),o.test(t)}function s(){var e=arguments.length<=0||void 0===arguments[0]?{}:arguments[0],t=arguments[1];for(var o in t)"undefined"==typeof e[o]&&(e[o]=t[o]);return e}function f(t,o){e(t);var r=void 0,i=void 0;"object"===("undefined"==typeof o?"undefined":ge(o))?(r=o.min||0,i=o.max):(r=arguments[1],i=arguments[2]);var n=encodeURI(t).split(/%..|./).length-1;return n>=r&&("undefined"==typeof i||n<=i)}function c(t,o){e(t),o=s(o,pe),o.allow_trailing_dot&&"."===t[t.length-1]&&(t=t.substring(0,t.length-1));var r=t.split(".");if(o.require_tld){var i=r.pop();if(!r.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(i))return!1}for(var n,l=0;l<r.length;l++){if(n=r[l],o.allow_underscores&&(n=n.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(n))return!1;if(/[\uff01-\uff5e]/.test(n))return!1;if("-"===n[0]||"-"===n[n.length-1])return!1}return!0}function d(t,o){if(e(t),o=s(o,me),o.allow_display_name){var r=t.match(he);r&&(t=r[1])}var i=t.split("@"),n=i.pop(),l=i.join("@"),a=n.toLowerCase();if("gmail.com"!==a&&"googlemail.com"!==a||(l=l.replace(/\./g,"").toLowerCase()),!f(l,{max:64})||!f(n,{max:256}))return!1;if(!c(n,{require_tld:o.require_tld}))return!1;if('"'===l[0])return l=l.slice(1,l.length-1),o.allow_utf8_local_part?$e.test(l):ve.test(l);for(var u=o.allow_utf8_local_part?Fe:_e,d=l.split("."),g=0;g<d.length;g++)if(!u.test(d[g]))return!1;return!0}function g(t){var o=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(e(t),o=String(o),!o)return g(t,4)||g(t,6);if("4"===o){if(!xe.test(t))return!1;var r=t.split(".").sort(function(e,t){return e-t});return r[3]<=255}if("6"===o){var i=t.split(":"),n=!1,l=g(i[i.length-1],4),a=l?7:8;if(i.length>a)return!1;if("::"===t)return!0;"::"===t.substr(0,2)?(i.shift(),i.shift(),n=!0):"::"===t.substr(t.length-2)&&(i.pop(),i.pop(),n=!0);for(var u=0;u<i.length;++u)if(""===i[u]&&u>0&&u<i.length-1){if(n)return!1;n=!0}else if(l&&u===i.length-1);else if(!Ae.test(i[u]))return!1;return n?i.length>=1:i.length===a}return!1}function p(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function m(e,t){for(var o=0;o<t.length;o++){var r=t[o];if(e===r||p(r)&&r.test(e))return!0}return!1}function h(t,o){if(e(t),!t||t.length>=2083||/\s/.test(t))return!1;if(0===t.indexOf("mailto:"))return!1;o=s(o,we);var r=void 0,i=void 0,n=void 0,l=void 0,a=void 0,u=void 0,f=void 0,d=void 0;if(f=t.split("#"),t=f.shift(),f=t.split("?"),t=f.shift(),f=t.split("://"),f.length>1){if(r=f.shift(),o.require_valid_protocol&&o.protocols.indexOf(r)===-1)return!1}else{if(o.require_protocol)return!1;o.allow_protocol_relative_urls&&"//"===t.substr(0,2)&&(f[0]=t.substr(2))}if(t=f.join("://"),f=t.split("/"),t=f.shift(),""===t&&!o.require_host)return!0;if(f=t.split("@"),f.length>1&&(i=f.shift(),i.indexOf(":")>=0&&i.split(":").length>2))return!1;l=f.join("@"),u=d=null;var p=l.match(be);return p?(n="",d=p[1],u=p[2]||null):(f=l.split(":"),n=f.shift(),f.length&&(u=f.join(":"))),!(null!==u&&(a=parseInt(u,10),!/^[0-9]+$/.test(u)||a<=0||a>65535))&&(!!(g(n)||c(n,o)||d&&g(d,6)||"localhost"===n)&&(n=n||d,!(o.host_whitelist&&!m(n,o.host_whitelist))&&(!o.host_blacklist||!m(n,o.host_blacklist))))}function _(t){return e(t),ye.test(t)}function v(t){return e(t),["true","false","1","0"].indexOf(t)>=0}function F(t){var o=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(e(t),o in ke)return ke[o].test(t);throw new Error("Invalid locale '"+o+"'")}function $(t){var o=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(e(t),o in De)return De[o].test(t);throw new Error("Invalid locale '"+o+"'")}function x(t){return e(t),Ie.test(t)}function A(t){return e(t),t===t.toLowerCase()}function w(t){return e(t),t===t.toUpperCase()}function b(t){return e(t),Re.test(t)}function y(t){return e(t),je.test(t)}function k(t){return e(t),ze.test(t)}function D(t){return e(t),je.test(t)&&ze.test(t)}function S(t){return e(t),Ne.test(t)}function E(t){return e(t),Ue.test(t)}function Z(t,o){e(t),o=o||{};var r=o.hasOwnProperty("allow_leading_zeroes")&&!o.allow_leading_zeroes?Be:Le,i=!o.hasOwnProperty("min")||t>=o.min,n=!o.hasOwnProperty("max")||t<=o.max;return r.test(t)&&i&&n}function O(t,o){return e(t),o=o||{},""!==t&&"."!==t&&(Pe.test(t)&&(!o.hasOwnProperty("min")||t>=o.min)&&(!o.hasOwnProperty("max")||t<=o.max))}function C(t){return e(t),""!==t&&qe.test(t)}function I(t){return e(t),Te.test(t)}function R(t,r){return e(t),o(t)%parseInt(r,10)===0}function j(t){return e(t),Me.test(t)}function z(t){return e(t),He.test(t)}function N(t){e(t);try{var o=JSON.parse(t);return!!o&&"object"===("undefined"==typeof o?"undefined":ge(o))}catch(e){}return!1}function U(t){return e(t),0===t.length}function B(t,o){e(t);var r=void 0,i=void 0;"object"===("undefined"==typeof o?"undefined":ge(o))?(r=o.min||0,i=o.max):(r=arguments[1],i=arguments[2]);var n=t.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],l=t.length-n.length;return l>=r&&("undefined"==typeof i||l<=i)}function L(t){var o=arguments.length<=1||void 0===arguments[1]?"all":arguments[1];e(t);var r=We[o];return r&&r.test(t)}function P(t){return e(t),I(t)&&24===t.length}function q(t){return e(t),Ye.test(t)}function T(e){var t=e.match(Ye),o=void 0,r=void 0,i=void 0,n=void 0;if(t){if(o=t[21],!o)return t[12]?null:0;if("z"===o||"Z"===o)return 0;r=t[22],o.indexOf(":")!==-1?(i=parseInt(t[23],10),n=parseInt(t[24],10)):(i=0,n=parseInt(t[23],10))}else{if(e=e.toLowerCase(),o=e.match(/(?:\s|gmt\s*)(-|\+)(\d{1,4})(\s|$)/),!o)return e.indexOf("gmt")!==-1?0:null;r=o[1];var l=o[2];3===l.length&&(l="0"+l),l.length<=2?(i=0,n=parseInt(l,10)):(i=parseInt(l.slice(0,2),10),n=parseInt(l.slice(2,4),10))}return(60*i+n)*("-"===r?1:-1)}function M(t){e(t);var o=new Date(Date.parse(t));if(isNaN(o))return!1;var r=T(t);if(null!==r){var i=o.getTimezoneOffset()-r;o=new Date(o.getTime()+6e4*i)}var n=String(o.getDate()),l=void 0,a=void 0,u=void 0;return!(a=t.match(/(^|[^:\d])[23]\d([^T:\d]|$)/g))||(l=a.map(function(e){return e.match(/\d+/g)[0]}).join("/"),u=String(o.getFullYear()).slice(-2),l===n||l===u||(l===""+n/u||l===""+u/n))}function H(o){var r=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];e(o);var i=t(r),n=t(o);return!!(n&&i&&n>i)}function W(o){var r=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];e(o);var i=t(r),n=t(o);return!!(n&&i&&n<i)}function Y(t,o){e(t);var r=void 0;if("[object Array]"===Object.prototype.toString.call(o)){var i=[];for(r in o)({}).hasOwnProperty.call(o,r)&&(i[r]=l(o[r]));return i.indexOf(t)>=0}return"object"===("undefined"==typeof o?"undefined":ge(o))?o.hasOwnProperty(t):!(!o||"function"!=typeof o.indexOf)&&o.indexOf(t)>=0}function G(t){e(t);var o=t.replace(/[^0-9]+/g,"");if(!Ge.test(o))return!1;for(var r=0,i=void 0,n=void 0,l=void 0,a=o.length-1;a>=0;a--)i=o.substring(a,a+1),n=parseInt(i,10),l?(n*=2,r+=n>=10?n%10+1:n):r+=n,l=!l;return!(r%10!==0||!o)}function J(t){if(e(t),!Je.test(t))return!1;for(var o=t.replace(/[A-Z]/g,function(e){return parseInt(e,36)}),r=0,i=void 0,n=void 0,l=!0,a=o.length-2;a>=0;a--)i=o.substring(a,a+1),n=parseInt(i,10),l?(n*=2,r+=n>=10?n+1:n):r+=n,l=!l;return parseInt(t.substr(t.length-1),10)===(1e4-r)%10}function K(t){var o=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(e(t),o=String(o),!o)return K(t,10)||K(t,13);var r=t.replace(/[\s-]+/g,""),i=0,n=void 0;if("10"===o){if(!Ke.test(r))return!1;for(n=0;n<9;n++)i+=(n+1)*r.charAt(n);if(i+="X"===r.charAt(9)?100:10*r.charAt(9),i%11===0)return!!r}else if("13"===o){if(!Qe.test(r))return!1;for(n=0;n<12;n++)i+=Ve[n%2]*r.charAt(n);if(r.charAt(12)-(10-i%10)%10===0)return!!r}return!1}function Q(t,o){return e(t),o in Xe&&Xe[o].test(t)}function V(e){var t="(\\"+e.symbol.replace(/\./g,"\\.")+")"+(e.require_symbol?"":"?"),o="-?",r="[1-9]\\d*",i="[1-9]\\d{0,2}(\\"+e.thousands_separator+"\\d{3})*",n=["0",r,i],l="("+n.join("|")+")?",a="(\\"+e.decimal_separator+"\\d{2})?",u=l+a;return e.allow_negatives&&!e.parens_for_negatives&&(e.negative_sign_after_digits?u+=o:e.negative_sign_before_digits&&(u=o+u)),e.allow_negative_sign_placeholder?u="( (?!\\-))?"+u:e.allow_space_after_symbol?u=" ?"+u:e.allow_space_after_digits&&(u+="( (?!$))?"),e.symbol_after_digits?u+=t:u=t+u,e.allow_negatives&&(e.parens_for_negatives?u="(\\("+u+"\\)|"+u+")":e.negative_sign_before_digits||e.negative_sign_after_digits||(u=o+u)),new RegExp("^(?!-? )(?=.*\\d)"+u+"$")}function X(t,o){return e(t),o=s(o,et),V(o).test(t)}function ee(t){e(t);var o=t.length;if(!o||o%4!==0||tt.test(t))return!1;var r=t.indexOf("=");return r===-1||r===o-1||r===o-2&&"="===t[o-1]}function te(t){return e(t),ot.test(t)}function oe(t,o){e(t);var r=o?new RegExp("^["+o+"]+","g"):/^\s+/g;return t.replace(r,"")}function re(t,o){e(t);for(var r=o?new RegExp("["+o+"]"):/\s/,i=t.length-1;i>=0&&r.test(t[i]);)i--;return i<t.length?t.substr(0,i+1):t}function ie(e,t){return re(oe(e,t),t)}function ne(t){return e(t),t.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/\\/g,"&#x5C;").replace(/`/g,"&#96;")}function le(t){return e(t),t.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#96;/g,"`")}function ae(t,o){return e(t),t.replace(new RegExp("["+o+"]+","g"),"")}function ue(t,o){e(t);var r=o?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return ae(t,r)}function se(t,o){return e(t),t.replace(new RegExp("[^"+o+"]+","g"),"")}function fe(t,o){e(t);for(var r=t.length-1;r>=0;r--)if(o.indexOf(t[r])===-1)return!1;return!0}function ce(e,t){if(t=s(t,rt),!d(e))return!1;var o=e.split("@",2);if(o[1]=o[1].toLowerCase(),"gmail.com"===o[1]||"googlemail.com"===o[1]){if(t.gmail_remove_subaddress&&(o[0]=o[0].split("+")[0]),t.gmail_remove_dots&&(o[0]=o[0].replace(/\./g,"")),!o[0].length)return!1;(t.all_lowercase||t.gmail_lowercase)&&(o[0]=o[0].toLowerCase()),o[1]=t.gmail_convert_googlemaildotcom?"gmail.com":o[1]}else if(~it.indexOf(o[1])){if(t.icloud_remove_subaddress&&(o[0]=o[0].split("+")[0]),!o[0].length)return!1;(t.all_lowercase||t.icloud_lowercase)&&(o[0]=o[0].toLowerCase())}else if(~nt.indexOf(o[1])){if(t.outlookdotcom_remove_subaddress&&(o[0]=o[0].split("+")[0]),!o[0].length)return!1;(t.all_lowercase||t.outlookdotcom_lowercase)&&(o[0]=o[0].toLowerCase())}else if(~lt.indexOf(o[1])){if(t.yahoo_remove_subaddress){var r=o[0].split("-");o[0]=r.length>1?r.slice(0,-1).join("-"):r[0]}if(!o[0].length)return!1;(t.all_lowercase||t.yahoo_lowercase)&&(o[0]=o[0].toLowerCase())}else t.all_lowercase&&(o[0]=o[0].toLowerCase());return o.join("@")}for(var de,ge="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e},pe={require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1},me={allow_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},he=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,_e=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,ve=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,Fe=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,$e=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i,xe=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,Ae=/^[0-9A-F]{1,4}$/i,we={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_host:!0,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1},be=/^\[([^\]]+)\](?::([0-9]+))?$/,ye=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/,ke={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[A-ZÉËÏÓÖÜ]+$/i,"hu-HU":/^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁ]+$/i,"sr-RS@latin":/^[A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},De={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"hu-HU":/^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"nl-NL":/^[0-9A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁ]+$/i,"sr-RS@latin":/^[0-9A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[0-9А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},Se=["AU","GB","HK","IN","NZ","ZA","ZM"],Ee=0;Ee<Se.length;Ee++)de="en-"+Se[Ee],ke[de]=ke["en-US"],De[de]=De["en-US"];ke["pt-BR"]=ke["pt-PT"],De["pt-BR"]=De["pt-PT"];for(var Ze,Oe=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],Ce=0;Ce<Oe.length;Ce++)Ze="ar-"+Oe[Ce],ke[Ze]=ke.ar,De[Ze]=De.ar;var Ie=/^[-+]?[0-9]+$/,Re=/^[\x00-\x7F]+$/,je=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,ze=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,Ne=/[^\x00-\x7F]/,Ue=/[\uD800-\uDBFF][\uDC00-\uDFFF]/,Be=/^(?:[-+]?(?:0|[1-9][0-9]*))$/,Le=/^[-+]?[0-9]+$/,Pe=/^(?:[-+]?(?:[0-9]+))?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/,qe=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/,Te=/^[0-9A-F]+$/i,Me=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i,He=/^[a-f0-9]{32}$/,We={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i},Ye=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/,Ge=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})|62[0-9]{14}$/,Je=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/,Ke=/^(?:[0-9]{9}X|[0-9]{10})$/,Qe=/^(?:[0-9]{13})$/,Ve=[1,3],Xe={"ar-DZ":/^(\+?213|0)(5|6|7)\d{8}$/,"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"ar-SA":/^(!?(\+?966)|0)?5\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"da-DK":/^(\+?45)?(\d{8})$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5)?|50)\s?(\d\s?){4,8}\d$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"hu-HU":/^(\+?36)(20|30|70)\d{7}$/,"it-IT":/^(\+?39)?\s?3\d{2} ?\d{6,7}$/,"ja-JP":/^(\+?81|0)\d{1,4}[ \-]?\d{1,4}[ \-]?\d{4}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nl-BE":/^(\+?32|0)4?\d{8}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pl-PL":/^(\+?48)? ?[5-8]\d ?\d{3} ?\d{2} ?\d{2}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"sr-RS":/^(\+3816|06)[- \d]{5,9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?1[345789]\d{9}$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};Xe["en-CA"]=Xe["en-US"],Xe["fr-BE"]=Xe["nl-BE"];var et={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_space_after_digits:!1},tt=/[^A-Z0-9+\/=]/i,ot=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9!\$&',\(\)\*\+,;=\-\._~:@\/\?%\s]*\s*$/i,rt={all_lowercase:!0,gmail_lowercase:!0,gmail_remove_dots:!0,gmail_remove_subaddress:!0,gmail_convert_googlemaildotcom:!0,outlookdotcom_lowercase:!0,outlookdotcom_remove_subaddress:!0,yahoo_lowercase:!0,yahoo_remove_subaddress:!0,icloud_lowercase:!0,icloud_remove_subaddress:!0},it=["icloud.com","me.com"],nt=["hotmail.at","hotmail.be","hotmail.ca","hotmail.cl","hotmail.co.il","hotmail.co.nz","hotmail.co.th","hotmail.co.uk","hotmail.com","hotmail.com.ar","hotmail.com.au","hotmail.com.br","hotmail.com.gr","hotmail.com.mx","hotmail.com.pe","hotmail.com.tr","hotmail.com.vn","hotmail.cz","hotmail.de","hotmail.dk","hotmail.es","hotmail.fr","hotmail.hu","hotmail.id","hotmail.ie","hotmail.in","hotmail.it","hotmail.jp","hotmail.kr","hotmail.lv","hotmail.my","hotmail.ph","hotmail.pt","hotmail.sa","hotmail.sg","hotmail.sk","live.be","live.co.uk","live.com","live.com.ar","live.com.mx","live.de","live.es","live.eu","live.fr","live.it","live.nl","msn.com","outlook.at","outlook.be","outlook.cl","outlook.co.il","outlook.co.nz","outlook.co.th","outlook.com","outlook.com.ar","outlook.com.au","outlook.com.br","outlook.com.gr","outlook.com.pe","outlook.com.tr","outlook.com.vn","outlook.cz","outlook.de","outlook.dk","outlook.es","outlook.fr","outlook.hu","outlook.id","outlook.ie","outlook.in","outlook.it","outlook.jp","outlook.kr","outlook.lv","outlook.my","outlook.ph","outlook.pt","outlook.sa","outlook.sg","outlook.sk","passport.com"],lt=["rocketmail.com","yahoo.ca","yahoo.co.uk","yahoo.com","yahoo.de","yahoo.fr","yahoo.in","yahoo.it","ymail.com"],at="6.0.0",ut={version:at,toDate:t,toFloat:o,toInt:r,toBoolean:i,equals:n,contains:a,matches:u,isEmail:d,isURL:h,isMACAddress:_,isIP:g,isFQDN:c,isBoolean:v,isAlpha:F,isAlphanumeric:$,isNumeric:x,isLowercase:A,isUppercase:w,isAscii:b,isFullWidth:y,isHalfWidth:k,isVariableWidth:D,isMultibyte:S,isSurrogatePair:E,isInt:Z,isFloat:O,isDecimal:C,isHexadecimal:I,isDivisibleBy:R,isHexColor:j,isMD5:z,isJSON:N,isEmpty:U,isLength:B,isByteLength:f,isUUID:L,isMongoId:P,isDate:M,isAfter:H,isBefore:W,isIn:Y,isCreditCard:G,isISIN:J,isISBN:K,isMobilePhone:Q,isCurrency:X,isISO8601:q,isBase64:ee,isDataURI:te,ltrim:oe,rtrim:re,trim:ie,escape:ne,unescape:le,stripLow:ue,whitelist:se,blacklist:ae,isWhitelisted:fe,normalizeEmail:ce,toString:l};return ut});